/*
FILE
	tJob source code of mysqlBind.cgi
	(built by mysqlRAD2.cgi (c) Gary Wallis 2001,2002 GPL Licensed)
	$Id: tjob.c,v 1.12 2003/11/13 20:44:21 ggw Exp $
	(tAuthorize.cPasswd template set member)
PURPOSE
*/

#include "mysqlrad.h"

//Table Variables
//uJob: Unique job ID
static unsigned uJob=0;
//uMasterJob: Unique group job ID
static unsigned uMasterJob=0;
//cJob: Job description
static char cJob[101]={""};
//cZone: Zone to be operated on
static char cZone[101]={""};
//uNameServer: Key into tNameServer
static unsigned uNameServer=0;
static char cuNameServerPullDown[256]={""};
//cTargetServer: Name of server that should process this job
static char cTargetServer[101]={""};
//uPriority: Job priority
static unsigned uPriority=0;
//uTime: Unix seconds threshold
static long unsigned uTime=0;
//cJobData: Aux job data
static char cJobData[101]={""};
//uOwner: Record owner
static unsigned uOwner=0;
//uCreatedBy: uClient for last insert
static unsigned uCreatedBy=0;
#define ISM3FIELDS
//uCreatedDate: Unix seconds date last insert
static long unsigned uCreatedDate=0;
//uModBy: uClient for last update
static unsigned uModBy=0;
//uModDate: Unix seconds date last update
static long unsigned uModDate=0;




#define VAR_LIST_tJob "tJob.uJob,tJob.uMasterJob,tJob.cJob,tJob.cZone,tJob.uNameServer,tJob.cTargetServer,tJob.uPriority,tJob.uTime,tJob.cJobData,tJob.uOwner,tJob.uCreatedBy,tJob.uCreatedDate,tJob.uModBy,tJob.uModDate"

 //Local only
void Insert_tJob(void);
void Update_tJob(char *rowid);
int InsertUpdate_tJob(char *cKey);
void ProcesstJobListVars(pentry entries[], int x);

 //In tJobfunc.h file included below
void ExtProcesstJobVars(pentry entries[], int x);
void ExttJobCommands(pentry entries[], int x);
void ExttJobButtons(void);
void ExttJobNavBar(void);
void ExttJobGetHook(entry gentries[], int x);
void ExttJobSelect(void);
void ExttJobSelectRow(void);
void ExttJobListSelect(void);
void ExttJobListFilter(void);
void ExttJobAuxTable(void);

#include "tjobfunc.h"

 //Table Variables Assignment Function
void ProcesstJobVars(pentry entries[], int x)
{
	register int i;


	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"uJob"))
			sscanf(entries[i].val,"%u",&uJob);
		else if(!strcmp(entries[i].name,"uMasterJob"))
			sscanf(entries[i].val,"%u",&uMasterJob);
		else if(!strcmp(entries[i].name,"cJob"))
			sprintf(cJob,"%.100s",entries[i].val);
		else if(!strcmp(entries[i].name,"cZone"))
			sprintf(cZone,"%.100s",FQDomainName(entries[i].val));
		else if(!strcmp(entries[i].name,"uNameServer"))
			sscanf(entries[i].val,"%u",&uNameServer);
		else if(!strcmp(entries[i].name,"cuNameServerPullDown"))
		{
			sprintf(cuNameServerPullDown,"%.255s",entries[i].val);
			uNameServer=ReadPullDown("tNameServer","cLabel",cuNameServerPullDown);
		}
		else if(!strcmp(entries[i].name,"cTargetServer"))
			sprintf(cTargetServer,"%.100s",entries[i].val);
		else if(!strcmp(entries[i].name,"uPriority"))
			sscanf(entries[i].val,"%u",&uPriority);
		else if(!strcmp(entries[i].name,"uTime"))
			sscanf(entries[i].val,"%lu",&uTime);
		else if(!strcmp(entries[i].name,"cJobData"))
			sprintf(cJobData,"%.100s",entries[i].val);
		else if(!strcmp(entries[i].name,"uOwner"))
			sscanf(entries[i].val,"%u",&uOwner);
		else if(!strcmp(entries[i].name,"uCreatedBy"))
			sscanf(entries[i].val,"%u",&uCreatedBy);
		else if(!strcmp(entries[i].name,"uCreatedDate"))
			sscanf(entries[i].val,"%lu",&uCreatedDate);
		else if(!strcmp(entries[i].name,"uModBy"))
			sscanf(entries[i].val,"%u",&uModBy);
		else if(!strcmp(entries[i].name,"uModDate"))
			sscanf(entries[i].val,"%lu",&uModDate);

	}

	//After so we can overwrite form data if needed.
	ExtProcesstJobVars(entries,x);

}//ProcesstJobVars()


void ProcesstJobListVars(pentry entries[], int x)
{
        register int i;

        for(i=0;i<x;i++)
        {
                if(!strncmp(entries[i].name,"ED",2))
                {
                        sscanf(entries[i].name+2,"%u",&uJob);
                        mode=6;
                        tJob("");
                }
        }
}//void ProcesstJobListVars(pentry entries[], int x)


int tJobCommands(pentry entries[], int x)
{
	ProcessControlVars(entries,x);

	ExttJobCommands(entries,x);

	if(!strcmp(function,"tJobTools"))
	{
		if(!strcmp(find,LANG_NB_LIST))
		{
			tJobList();
		}

		//Default
		ProcesstJobVars(entries,x);
		tJob("");
	}
	else if(!strcmp(function,"tJobList"))
	{
		ProcessControlVars(entries,x);
		ProcesstJobListVars(entries,x);
		tJobList();
	}

	return(0);

}//tJobCommands()


void tJob(char *result)
{
	MYSQL_RES *res;
	MYSQL_RES *res2;
	MYSQL_ROW field;

	//Internal skip reloading
	if(!result[0])
	{
		if(mode)
			ExttJobSelectRow();
		else
			ExttJobSelect();

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
        	{
			if(strstr(mysql_error(&mysql)," doesn't exist"))
                	{
				CreatetJob();
				mysqlBind("New tJob table created");
                	}
			else
			{
				mysqlBind(mysql_error(&mysql));
			}
        	}

		res=mysql_store_result(&mysql);
		if((i=mysql_num_rows(res)))
		{
			if(mode==6)
			{
			sprintf(query,"SELECT _rowid FROM tJob WHERE uJob=%u"
						,uJob);
			mysql_query(&mysql,query);
			res2=mysql_store_result(&mysql);
			field=mysql_fetch_row(res2);
			sscanf(field[0],"%lu",&rowid);
			rowid++;
			}
			PageMachine("",0,"");
			if(!mode) mysql_data_seek(res,rowid-1);
			field=mysql_fetch_row(res);
		sscanf(field[0],"%u",&uJob);
		sscanf(field[1],"%u",&uMasterJob);
		sprintf(cJob,"%.100s",field[2]);
		sprintf(cZone,"%.100s",field[3]);
		sscanf(field[4],"%u",&uNameServer);
		sprintf(cTargetServer,"%.100s",field[5]);
		sscanf(field[6],"%u",&uPriority);
		sscanf(field[7],"%lu",&uTime);
		sprintf(cJobData,"%.100s",field[8]);
		sscanf(field[9],"%u",&uOwner);
		sscanf(field[10],"%u",&uCreatedBy);
		sscanf(field[11],"%lu",&uCreatedDate);
		sscanf(field[12],"%u",&uModBy);
		sscanf(field[13],"%lu",&uModDate);

		}

	}//Internal Skip

	Header_ism3(":: tJob",0);
	printf("<form action=mysqlBind.cgi method=post >\n");
	printf("<table width=900 border=0 bgcolor=#A9BEC0 valign=center>\n");
	printf("<tr><td colspan=2><font face=Arial,Helvetica size=2>");


	ExttJobNavBar();

	printf("<input type=hidden name=function value=tJobTools>");
	printf("<input type=hidden name=rowid value=%lu>",rowid);
	if(i)
	{
		printf(" <font color=blue >");
		if(mode==6)
			//printf(" Found");
			printf(LANG_NBR_FOUND);
		else if(mode==5)
			//printf(" Modified");
			printf(LANG_NBR_MODIFIED);
		else if(mode==4)
			//printf(" New");
			printf(LANG_NBR_NEW);
		printf(LANG_NBRF_SHOWING,rowid,i);
	}
	else
	{
		if(!result[0])
		//printf(" No records found");
		printf(LANG_NBR_NORECS);
	}
	if(result[0]) printf(" <b> %s",result);
	printf("</td></tr>");
	printf("<tr><td valign=top>");

        ExttJobButtons();

        printf("</td><td valign=top>");
	printf("<table width=630 border=0 bgcolor=#9BC1B3 valign=center>\n");

	if(mode==2000 || mode==2002)
		tJobInputContent();
	else
		tJobContent();

	printf("</table>\n");
	printf("</table>\n");

	//Bottom table
        ExttJobAuxTable();

	printf("</font></form>\n");
	Footer_ism3();

}//end of tJob();


void tJobContent(void)
{

	OpenRow(LANG_FL_tJob_uJob,"white");
	printf("%u<input type=hidden name=uJob value=%u >\n",uJob,uJob);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_uMasterJob,"white");
	printf("%u<input type=hidden name=uMasterJob value=%u >\n",uMasterJob,uMasterJob);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_cJob,"white");
	printf("%s<input type=hidden name=cJob value=\"%s\">",cJob,EncodeDoubleQuotes(cJob));
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_cZone,"white");
	printf("%s<input type=hidden name=cZone value=\"%s\">",cZone,EncodeDoubleQuotes(cZone));
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_uNameServer,"white");
	tTablePullDownReadOnly("tNameServer;cuNameServerPullDown","cLabel","cLabel",uNameServer);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_cTargetServer,"white");
	printf("%s<input type=hidden name=cTargetServer value=\"%s\">",cTargetServer,EncodeDoubleQuotes(cTargetServer));
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_uPriority,"white");
	printf("%u<input type=hidden name=uPriority value=%u >\n",uPriority,uPriority);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_uTime,"white");
	if(uTime)
		printf("%s\n\n",ctime(&uTime));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uTime value=%lu >\n",uTime);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_cJobData,"white");
	printf("%s<input type=hidden name=cJobData value=\"%s\">",cJobData,EncodeDoubleQuotes(cJobData));
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_uOwner,"white");
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_uCreatedBy,"white");
	printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_uCreatedDate,"white");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_uModBy,"white");
	printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tJob_uModDate,"white");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");



}//tJobContent()


void tJobInputContent(void)
{

	OpenRow(LANG_FL_tJob_uJob,"white");
	if(uPermLevel>=20)
		printf("<input title='%s' type=text name=uJob value=%u size=16 maxlength=10>\n",LANG_FT_tJob_uJob,uJob);
	else
		printf("%u<input type=hidden name=uJob value=%u >\n",uJob,uJob);
	OpenRow(LANG_FL_tJob_uMasterJob,"white");
	if(uPermLevel>=20)
		printf("<input title='%s' type=text name=uMasterJob value=%u size=16 maxlength=10>\n",LANG_FT_tJob_uMasterJob,uMasterJob);
	else
		printf("%u<input type=hidden name=uMasterJob value=%u >\n",uMasterJob,uMasterJob);
	OpenRow(LANG_FL_tJob_cJob,"white");
	printf("<input title='%s' type=text name=cJob value=\"%s\" size=40 maxlength=100>\n",LANG_FT_tJob_cJob,EncodeDoubleQuotes(cJob));
	OpenRow(LANG_FL_tJob_cZone,"white");
	printf("<input title='%s' type=text name=cZone value=\"%s\" size=40 maxlength=100>\n",LANG_FT_tJob_cZone,EncodeDoubleQuotes(cZone));
	OpenRow(LANG_FL_tJob_uNameServer,"white");
	if(uPermLevel>=0)
		tTablePullDown("tNameServer;cuNameServerPullDown","cLabel","cLabel",uNameServer);
	else
	{
		tTablePullDownReadOnly("tNameServer;cuNameServerPullDown","cLabel","cLabel",uNameServer);
	}
	OpenRow(LANG_FL_tJob_cTargetServer,"white");
	printf("<input title='%s' type=text name=cTargetServer value=\"%s\" size=40 maxlength=100>\n",LANG_FT_tJob_cTargetServer,EncodeDoubleQuotes(cTargetServer));
	OpenRow(LANG_FL_tJob_uPriority,"white");
	printf("<input title='%s' type=text name=uPriority value=%u size=16 maxlength=10>\n",LANG_FT_tJob_uPriority,uPriority);
	OpenRow(LANG_FL_tJob_uTime,"white");
	if(uTime)
		printf("%s\n\n",ctime(&uTime));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uTime value=%lu >\n",uTime);
	OpenRow(LANG_FL_tJob_cJobData,"white");
	printf("<input title='%s' type=text name=cJobData value=\"%s\" size=40 maxlength=100>\n",LANG_FT_tJob_cJobData,EncodeDoubleQuotes(cJobData));
	OpenRow(LANG_FL_tJob_uOwner,"white");
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);
	OpenRow(LANG_FL_tJob_uCreatedBy,"white");
	printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);
	OpenRow(LANG_FL_tJob_uCreatedDate,"white");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);
	OpenRow(LANG_FL_tJob_uModBy,"white");
	printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);
	OpenRow(LANG_FL_tJob_uModDate,"white");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("</tr>\n");



}//void tJobInputContent(void)


void NewtJob(unsigned uMode)
{
	register int i=0;
	MYSQL_RES *res;

	//New select
	sprintf(query,"SELECT uJob FROM tJob\
				WHERE uJob=%u"
							,uJob);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	if(i) 
		//tJob("<blink>Record already exists");
		tJob(LANG_NBR_RECEXISTS);

	//insert query
	Insert_tJob();
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"New record %u added");
	uJob=mysql_insert_id(&mysql);

	if(!uMode)
	{
	sprintf(query,LANG_NBR_NEWRECADDED,uJob);
	tJob(query);
	}

}//NewtJob(unsigned uMode)


void DeletetJob(void)
{
#ifdef ISM3FIELDS
	sprintf(query,"DELETE FROM tJob WHERE uJob=%u AND ( uOwner=%u OR %u>9 )"
					,uJob,uLoginClient,uPermLevel);
#else
	sprintf(query,"DELETE FROM tJob WHERE uJob=%u"
					,uJob);
#endif
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));

	//tJob("Record Deleted");
	if(mysql_affected_rows(&mysql)>0)
		tJob(LANG_NBR_RECDELETED);
	else
		tJob(LANG_NBR_RECNOTDELETED);

}//void DeletetJob(void)


void Insert_tJob(void)
{

#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//insert query

	//insert query
	sprintf(query,"INSERT INTO tJob SET  uJob=%u, uMasterJob=%u, cJob='%s', cZone='%s', uNameServer=%u, cTargetServer='%s', uPriority=%u, uTime=%lu, cJobData='%s', uOwner=%u, uCreatedBy=%u, uCreatedDate=%lu, uModBy=%u, uModDate=0",
			uJob
			,uMasterJob
			,TextAreaSave(cJob)
			,TextAreaSave(cZone)
			,uNameServer
			,TextAreaSave(cTargetServer)
			,uPriority
			,uTime
			,TextAreaSave(cJobData)
			,uOwner
			,uCreatedBy
			,(long unsigned)clock
			,uModBy
			);


	mysql_query(&mysql,query);
#ifdef ISM3FIELDS
	uCreatedDate=clock;
#endif

}//void Insert_tJob(void)


void Update_tJob(char *rowid)
{
#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//update query

	//update query
	sprintf(query,"UPDATE tJob SET uJob=%u,uMasterJob=%u,cJob='%s',cZone='%s',uNameServer=%u,cTargetServer='%s',uPriority=%u,uTime=%lu,cJobData='%s',uModBy=%u,uModDate=%lu WHERE _rowid=%s",
			uJob
			,uMasterJob
			,TextAreaSave(cJob)
			,TextAreaSave(cZone)
			,uNameServer
			,TextAreaSave(cTargetServer)
			,uPriority
			,uTime
			,TextAreaSave(cJobData)
			,uModBy
			,(long unsigned)clock
			,rowid);


	mysql_query(&mysql,query);

#ifdef ISM3FIELDS
	uModDate=clock;
#endif

}//void Update_tJob(void)


void ModtJob(void)
{
	register int i=0;
	MYSQL_RES *res;
	MYSQL_ROW field;
#ifdef ISM3FIELDS
	unsigned uPreModDate=0;

	//Mod select query
	if(uPermLevel<10)
	sprintf(query,"SELECT tJob.uJob,\
				tJob.uModDate\
				FROM tJob,tClient\
				WHERE tJob.uJob=%u\
				AND tJob.uOwner=tClient.uClient\
				AND (tClient.uOwner=%u OR tClient.uClient=%u)"
			,uJob,uLoginClient,uLoginClient);
	else
	sprintf(query,"SELECT uJob,uModDate FROM tJob\
				WHERE uJob=%u"
						,uJob);
#else
	sprintf(query,"SELECT uJob FROM tJob\
				WHERE uJob=%u"
						,uJob);
#endif

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	//if(i<1) tJob("<blink>Record does not exist");
	if(i<1) tJob(LANG_NBR_RECNOTEXIST);
	//if(i>1) tJob("<blink>Multiple rows!");
	if(i>1) tJob(LANG_NBR_MULTRECS);

	field=mysql_fetch_row(res);
#ifdef ISM3FIELDS
	sscanf(field[1],"%u",&uPreModDate);
	if(uPreModDate!=uModDate) tJob(LANG_NBR_EXTMOD);
#endif

	Update_tJob(field[0]);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"record %s modified",field[0]);
	sprintf(query,LANG_NBRF_REC_MODIFIED,field[0]);
	tJob(query);

}//ModtJob(void)


void tJobList(void)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	ExttJobListSelect();

	mysql_query(&mysql,query);
	if(mysql_error(&mysql)[0]) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	PageMachine("tJobList",1,"");//1 is auto header list mode. Opens table!

	//Filter select drop down
	ExttJobListFilter();

	printf("<input type=text size=16 name=command maxlength=98 value=\"%s\" >",command);

	printf("</table>\n");

	printf("<table bgcolor=#9BC1B3 border=0 width=900>\n");
	printf("<tr bgcolor=black><td><font face=arial,helvetica color=white>uJob<td><font face=arial,helvetica color=white>uMasterJob<td><font face=arial,helvetica color=white>cJob<td><font face=arial,helvetica color=white>cZone<td><font face=arial,helvetica color=white>uNameServer<td><font face=arial,helvetica color=white>cTargetServer<td><font face=arial,helvetica color=white>uPriority<td><font face=arial,helvetica color=white>uTime<td><font face=arial,helvetica color=white>cJobData<td><font face=arial,helvetica color=white>uOwner<td><font face=arial,helvetica color=white>uCreatedBy<td><font face=arial,helvetica color=white>uCreatedDate<td><font face=arial,helvetica color=white>uModBy<td><font face=arial,helvetica color=white>uModDate</tr>");



	mysql_data_seek(res,start-1);

	for(n=0;n<(end-start+1);n++)
	{
		field=mysql_fetch_row(res);
		if(!field)
		{
			printf("<tr><td><font face=arial,helvetica>End of data</table>");
			Footer_ism3();
		}
			if(n % 2)
				printf("<tr bgcolor=#BBE1D3>");
			else
				printf("<tr>");
		printf("<td><font face=arial,helvetica size=1><input type=submit name=ED%s value=Edit></font> %s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s</tr>"
			,field[0]
			,field[0]
			,field[1]
			,field[2]
			,field[3]
			,field[4]
			,field[5]
			,field[6]
			,field[7]
			,field[8]
			,field[9]
			,field[10]
			,field[11]
			,field[12]
			,field[13]
				);

	}

	printf("</table></form>\n");
	Footer_ism3();

}//tJobList()


void CreatetJob(void)
{
	sprintf(query,"CREATE TABLE tJob ( uOwner int unsigned NOT NULL DEFAULT 0,index (uOwner), uCreatedBy int unsigned NOT NULL DEFAULT 0, uCreatedDate int unsigned NOT NULL DEFAULT 0, uModBy int unsigned NOT NULL DEFAULT 0, uModDate int unsigned NOT NULL DEFAULT 0, uJob int unsigned NOT NULL DEFAULT 0 PRIMARY KEY AUTO_INCREMENT, cJob varchar(100) NOT NULL DEFAULT '', uNameServer int unsigned NOT NULL DEFAULT 0,index (uNameServer), cZone varchar(100) NOT NULL DEFAULT '', uPriority int unsigned NOT NULL DEFAULT 0, uTime int unsigned NOT NULL DEFAULT 0, cTargetServer varchar(100) NOT NULL DEFAULT '', uMasterJob int unsigned NOT NULL DEFAULT 0, cJobData varchar(100) NOT NULL DEFAULT '' )");
	mysql_query(&mysql,qstr);
	if(mysql_errno(&mysql))
		mysqlBind(mysql_error(&mysql));
}//CreatetJob()

